angular.module('dgEntity', ['drupalgap'])

// ~ hook_menu()
.config(['$routeProvider', function($routeProvider) {

      var entity_types = drupal_entity_types();
      
      // Add routes to view entities.
      for (var i = 0; i < entity_types.length; i++) {
        var entity_type = entity_types[i];
        var view_route = '/' + entity_type + '/:' + drupal_entity_primary_key(entity_type);
        $routeProvider.when(view_route, {
            templateUrl: 'themes/spi/page.tpl.html',
            controller: 'dg_page_controller',
            page_callback: 'dg_entity_page_view',
            page_arguments: [0, 1]
        });
      }
      
}])

.directive("entityView", function($compile, drupal) {
    return {
      controller: function($scope) {
        var entity_type = arg(0);
        var entity_id = arg(1);
        $scope.entity_type = entity_type;
        $scope.entity_id = entity_id;
        $scope.entity_load = {
          entity: drupal[entity_type + '_load'](entity_id)
        };
      },
      //replace: true,
      link: function(scope, element, attrs) {
        scope.entity_load.entity.then(function (entity) {
            //console.log(scope);
            //console.log(entity);
            
            var content = { };
            
            // Grab this entity's field info instances.
            var instances = drupalgap_field_info_instances(
              scope.entity_type,
              entity.type // @TODO support all entity types, not just nodes
            );
            //console.log(instances);
            
            // Render each field instance...
            for (var field_name in instances) {
              if (!instances.hasOwnProperty(field_name)) { continue; }
              var instance = instances[field_name];
              
              // Extract the drupalgap display mode and the module name in
              // charge of the field's formatter view hook.
              var display = instance.display.drupalgap;
              var module = display.module;
              var hook = module + '_field_formatter_view';
              
              // Invoke the hook_field_formmater_view(), if it exists.
              if (!dg_function_exists(hook)) { console.log(hook + '() missing!'); continue; }
              content[field_name] = window[hook](
                scope.entity_type,
                entity,
                dg_field_info_field(field_name),
                instance,
                entity.language,
                entity[field_name][entity.language],
                display
              );
              
            }
            
            element.replaceWith($compile(drupalgap_render(content))(scope));
        });
      }
    };
});

/**
 *
 */
function dg_entity_page_view(entity_type, entity_id) {
  try {
    return '<entity-view></entity';
    //var directive_name = entity_type.replace(/_/g, '-') + '-view';
    //return '<' + directive_name + '></' + directive_name + '>';
  }
  catch (error) { console.log('dg_entity_page_view - ' + error); }
}
